Wt: Wt::WAbstractListModel Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WAbstractListModel Class Reference
Model/view system

An abstract list model for use with Wt's view classes. More...

`#include <Wt/WAbstractListModel>`

Inheritance diagram for Wt::WAbstractListModel:
[legend]

List of all members.

## Public Member Functions
| WAbstractListModel (WObject *parent=0)
| Create a new abstract list model.
| ~WAbstractListModel ()
| Destructor.
virtual WModelIndex | parent (const WModelIndex &index) const
| Returns the parent for a model index.
virtual WModelIndex | index (int row, int column, const WModelIndex &parent=WModelIndex()) const
| Returns the child index for the given row and column.
virtual int | columnCount (const WModelIndex &parent=WModelIndex()) const
| Returns the number of columns.

## Detailed Description

An abstract list model for use with Wt's view classes.

An abstract list model specializes WAbstractItemModel for one-dimensional lists (i.e. a model with 1 column and no children).

It cannot be used directly but must be subclassed. Subclassed models must at least reimplement rowCount() to return the number of rows, and data() to return data.

## Member Function Documentation

int Wt::WAbstractListModel::columnCount | ( | const WModelIndex & | parent = `WModelIndex()` | ) | const`[virtual]`

Returns the number of columns.

This returns the number of columns at index `parent`.

See also:
  rowCount()

Implements Wt::WAbstractItemModel.

WModelIndex Wt::WAbstractListModel::index | ( | int | row,
|  | int | column,
|  | const WModelIndex & | parent = `WModelIndex()`
| ) |  | const`[virtual]`

Returns the child index for the given row and column.

When implementing this method, you can use createIndex() to create an index that corresponds to the item at `row` and `column` within `parent`.

If the location is invalid (out of bounds at the parent), then an invalid index must be returned.

See also:
  parent()

Implements Wt::WAbstractItemModel.

WModelIndex Wt::WAbstractListModel::parent | ( | const WModelIndex & | index | ) | const`[virtual]`

Returns the parent for a model index.

An implementation should use createIndex() to create a model index that corresponds to the parent of a given index.

Note that the index itself may be stale (referencing a row/column within the parent that is outside the model geometry), but its parent (identified by the WModelIndex::internalPointer()) is referencing an existing parent. A stale index can only be used while the model geometry is being updated, i.e. during the emission of the corresponding [rows/columns](Being)[Removed/Inserted]() signals.

See also:
  index()

Implements Wt::WAbstractItemModel.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator